pipeline {
    agent any

    tools {
        // Maven version configured "3.6.2"
        maven "MAVEN_3.6.2"
    }
	
	triggers { 
	    upstream(upstreamProjects: 'https://docker.everisdigital.com/jenkins/project/demo-master-multibranch/development', threshold: hudson.model.Result.SUCCESS) 
	}

    stages {
        stage('Checkout: GitLab') {
            steps {
                // Get code from a GitHub repository
                //git branch: 'development', credentialsId: 'GitLabCredentials', url: 'http://docker.everisdigital.com:8888/smontoyo/demo-master.git'
				git credentialsId: 'GitLabCredentials', url: 'http://docker.everisdigital.com:8888/smontoyo/demo-master.git'
            }
        }
        
        stage('Build: MVN') {
            steps {
                // Run Maven on a Unix agent.
                //sh "mvn -Dmaven.test.failure.ignore=true clean package"
                //sh "mvn clean install"
                //sh "mvn eclipse:clean org.jacoco:jacoco-maven-plugin:prepare-agent install"
                configFileProvider(
                    [configFile(fileId: 'artifactory_settings', variable: 'MAVEN_SETTINGS')]) {
                    sh 'mvn -s $MAVEN_SETTINGS deploy'
                }
            }
        }
        
        stage('SonarQube') {
            steps {
                withSonarQubeEnv('SonarQube') {
                    sh "mvn clean verify sonar:sonar " +
                    "-Dsonar.projectName=demo_master " + 
                    "-Dsonar.projectKey=demo_master"
                }
            }
        }
        
        stage('Build Imagen') {
            steps {
                withSonarQubeEnv('SonarQube') {
                    sh "docker version "
                }
            }
        }
    }
}